# coding: utf-8

"""
    Prevision.io

    Prevision.io Studio APIs  # noqa: E501

    OpenAPI spec version: 1.0.5
    Contact: web@prevision.io
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class ProjectIdPipelinetemplatesBody(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'name': 'str',
        'config_dataset_id': 'str',
        'nodes': 'list[ProjectsprojectIdpipelinetemplatesNodes]'
    }

    attribute_map = {
        'name': 'name',
        'config_dataset_id': 'config_dataset_id',
        'nodes': 'nodes'
    }

    def __init__(self, name=None, config_dataset_id=None, nodes=None):  # noqa: E501
        """ProjectIdPipelinetemplatesBody - a model defined in Swagger"""  # noqa: E501
        self._name = None
        self._config_dataset_id = None
        self._nodes = None
        self.discriminator = None
        if name is not None:
            self.name = name
        if config_dataset_id is not None:
            self.config_dataset_id = config_dataset_id
        if nodes is not None:
            self.nodes = nodes

    @property
    def name(self):
        """Gets the name of this ProjectIdPipelinetemplatesBody.  # noqa: E501


        :return: The name of this ProjectIdPipelinetemplatesBody.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this ProjectIdPipelinetemplatesBody.


        :param name: The name of this ProjectIdPipelinetemplatesBody.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def config_dataset_id(self):
        """Gets the config_dataset_id of this ProjectIdPipelinetemplatesBody.  # noqa: E501


        :return: The config_dataset_id of this ProjectIdPipelinetemplatesBody.  # noqa: E501
        :rtype: str
        """
        return self._config_dataset_id

    @config_dataset_id.setter
    def config_dataset_id(self, config_dataset_id):
        """Sets the config_dataset_id of this ProjectIdPipelinetemplatesBody.


        :param config_dataset_id: The config_dataset_id of this ProjectIdPipelinetemplatesBody.  # noqa: E501
        :type: str
        """

        self._config_dataset_id = config_dataset_id

    @property
    def nodes(self):
        """Gets the nodes of this ProjectIdPipelinetemplatesBody.  # noqa: E501


        :return: The nodes of this ProjectIdPipelinetemplatesBody.  # noqa: E501
        :rtype: list[ProjectsprojectIdpipelinetemplatesNodes]
        """
        return self._nodes

    @nodes.setter
    def nodes(self, nodes):
        """Sets the nodes of this ProjectIdPipelinetemplatesBody.


        :param nodes: The nodes of this ProjectIdPipelinetemplatesBody.  # noqa: E501
        :type: list[ProjectsprojectIdpipelinetemplatesNodes]
        """

        self._nodes = nodes

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ProjectIdPipelinetemplatesBody, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ProjectIdPipelinetemplatesBody):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
